/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Turno;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTurno;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTurnoController")
@Scope("prototype")
public class BusquedaTurnoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Turno> plwTurno;
    private MyListbox turnoList;
    private Paging pagingTurno;
    private Textbox txtNome;

    public Paging getPagingTurno() {
        return pagingTurno;
    }

    public void setPagingTurno(Paging pagingTurno) {
        this.pagingTurno = pagingTurno;
    }

    public MyListbox getTurnoList() {
        return turnoList;
    }

    public void setTurnoList(MyListbox turnoList) {
        this.turnoList = turnoList;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        turnoList.setItemRenderer(new RenderTurno());
        turnoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Turno a = (Turno) turnoList.getSelected();
                verTurno(a);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verTurno(Turno t) {
        if (t == null) {
            return;
        }

        Map args = new HashMap();
        args.put("turno", t);
        args.put("turnoList", turnoList);

        openWindow("/gui/catalogos/editarTurno.zul",
                Labels.getLabel("editarTurnoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Turno> turnoBusqueda =
                new HibernateSearchObject<Turno>(Turno.class,
                pagingTurno.getPageSize());

        turnoBusqueda.addFilterLike("descturno",
                "%" + txtNome.getText().trim().concat("%"));

        turnoBusqueda.addSortAsc("descturno");
        turnoBusqueda.addFilterEqual("activo", Boolean.TRUE);
        turnoBusqueda.addFilterNotEqual("turnoId", -1);
        plwTurno.init(turnoBusqueda, turnoList, pagingTurno);

        if (turnoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTurnoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTurno(new Turno());
    }
}
